#SYMBIAN_TARGET=armi
#MK_TARGET=gui

MK_OPTIMIZE=FAST
MK_VENDOR=NIBOX
MK_YEAR=2007
EX_NAME=nve
EX_SRC=nvemain
EX_SRCEXT=c
EX_SRCPATH=$(MK_DEVEL)/nve
EX_OBJ=$(MK_OUT)/nveui.$(OBJ_EXT) $(MK_OUT)/nveffect.$(OBJ_EXT)
EX_STACKSIZE=65536
EX_HEAPMIN=1000000
EX_HEAPMAX=10000000
#EX_OBJ=$(MK_OUT)/VRexPlayerAdapter.$(OBJ_EXT) $(MK_OUT)/VRexFileDetails.$(OBJ_EXT)
#EX_OBJ=$(MK_OUT)/ffmpeg.$(OBJ_EXT) $(MK_OUT)/cmdutils.$(OBJ_EXT) $(MK_OUT)/ffmpeg_p.$(OBJ_EXT) $(FFMAVC_OBJ) $(FFMAVF_OBJ) $(FFMAVU_OBJ) $(FFMSWS_OBJ)
EX_LIB=$(LSH_PREF)coral$(LIB_MOD)$(LSH_SUFF) $(LSH_PREF)image$(LIB_MOD)$(LSH_SUFF) $(LSH_PREF)orion$(LIB_MOD)$(LSH_SUFF) $(LIB_UI) $(LIB_MM) $(LIB_C) $(LIB_DL) $(LIB_THREAD) $(LIB_BLUETOOTH) $(LIB_INET) $(LSH_PREF)ffmpeg$(LSH_SUFF) 
MK_CC_OPT=-D__GLOBAL_UNSUPPORTED__ -D__CXXBUILD__ -D__INTEGERX_UNSUPPORTED__ -I$(MK_DEVEL)/ffmpeg_p -I$(MK_DEVEL)/ffmpeg -I$(MK_DEVEL)/ffmpeg/libavformat -I$(MK_DEVEL)/ffmpeg/libavcodec -I$(MK_DEVEL)/ffmpeg/libavutil -I$(MK_DEVEL)/ffmpeg/libswscale
#MK_CC_OPT= -I$(MK_DEVEL)/ffmpeg_p -I$(MK_DEVEL)/ffmpeg -I$(MK_DEVEL)/ffmpeg/libavformat -I$(MK_DEVEL)/ffmpeg/libavcodec -I$(MK_DEVEL)/ffmpeg/libavutil -I$(MK_DEVEL)/ffmpeg/libswscale

SYMBIAN_EX_UID=0009075
#SYMBIAN_EX_UID_HEADER=$(EX_SRCPATH)/nveuid.h
EX_MAIN_PLATFORM=default
EX_MAIN_OPTION=$(O_DEF)GEMAIN_MEMORY_LEAK $(O_DEF)GEMAIN_ALLOC_HOOK
EX_MAIN_RESOURCE=custom

FFSRC=x
FFM_SRCEXT=cpp
FFMCC=$(EX_CC)
FFM=$(MK_DEVEL)/ffmpeg
FFMAVC=$(FFM)/libavcodec
FFMAVF=$(FFM)/libavformat
FFMAVU=$(FFM)/libavutil
FFMSWS=$(FFM)/libswscale
FFMPORT=$(MK_DEVEL)/ffmpeg_p

include $(MK_DEVEL)/ffmpeg_p/config.mak

include $(MK_TEMPLATE_ROOT)/symbol.mk
include $(FFMPORT)/avcm.mk
include $(FFMPORT)/avfm.mk
include $(FFMPORT)/avum.mk
include $(FFMPORT)/swsm.mk
include $(MK_EXECUTE)
$(MK_OUT)/nveui.$(OBJ_EXT) : $(EX_SRCPATH)/nveui.c
	$(EX_CC) $(EX_SRCPATH)/nveui.c

$(MK_OUT)/nveffect.$(OBJ_EXT) : $(EX_SRCPATH)/nveffect.c
	$(EX_CC) $(EX_SRCPATH)/nveffect.c

$(MK_OUT)/ffmpeg.$(OBJ_EXT) : $(FFM)/ffmpeg.$(FFM_SRCEXT)
	$(FFMCC) $(FFM)/ffmpeg.$(FFM_SRCEXT)

$(MK_OUT)/cmdutils.$(OBJ_EXT) : $(FFM)/cmdutils.$(FFM_SRCEXT)
	$(FFMCC) $(FFM)/cmdutils.$(FFM_SRCEXT)

$(MK_OUT)/ffmpeg_p.$(OBJ_EXT) : $(FFMPORT)/ffmpeg_p.$(FFM_SRCEXT)
	$(FFMCC) $(FFMPORT)/ffmpeg_p.$(FFM_SRCEXT)

include $(FFMPORT)/avcd$(FFSRC).mk
include $(FFMPORT)/avfd$(FFSRC).mk
include $(FFMPORT)/avud$(FFSRC).mk
include $(FFMPORT)/swsd$(FFSRC).mk

$(MK_OUT)/VRexPlayerAdapter.$(OBJ_EXT) : $(EX_SRCPATH)/VRexPlayerAdapter.cpp
	$(EX_CC) $(EX_SRCPATH)/VRexPlayerAdapter.cpp

$(MK_OUT)/VRexFileDetails.$(OBJ_EXT) : $(EX_SRCPATH)/VRexFileDetails.cpp
	$(EX_CC) $(EX_SRCPATH)/VRexFileDetails.cpp

package:
	$(MK_PACKAGE) file $(MK_SH)/$(SH_PREF)ffmpeg$(LIB_MOD)$(SH_SUFF)
	$(MK_PACKAGE) file $(MK_SH)/$(SH_PREF)coral$(LIB_MOD)$(SH_SUFF)
	$(MK_PACKAGE) file $(MK_SH)/$(SH_PREF)imath$(LIB_MOD)$(SH_SUFF)
	$(MK_PACKAGE) file $(MK_SH)/$(SH_PREF)image$(LIB_MOD)$(SH_SUFF)
	$(MK_PACKAGE) file $(MK_SH)/$(SH_PREF)orion$(LIB_MOD)$(SH_SUFF)
	$(MK_PACKAGE) file $(MK_EX)/$(EX_NAME)$(EX_SUFF)

clean:
	make $(MK_PATH)/nve.mk clean_execute
	$(MK_RM) $(MK_OUT)/nveui.$(OBJ_EXT)
	$(MK_RM) $(MK_OUT)/nveffect.$(OBJ_EXT)

#	make -f nve.mk clean_avc
#	make -f nve.mk clean_avu
#	make -f nve.mk clean_avf
#	$(MK_RM) $(MK_OUT)/ffmpeg.$(OBJ_EXT)
#	$(MK_RM) $(MK_OUT)/ffmpeg_p.$(OBJ_EXT)
#	$(MK_RM) $(MK_OUT)/cmdutils.$(OBJ_EXT)

#	$(MK_RM) $(MK_OUT)/avio.$(OBJ_EXT)
#	$(MK_RM) $(MK_OUT)/aviobuf.$(OBJ_EXT)
#	$(MK_RM) $(MK_OUT)/framehook.$(OBJ_EXT)
#	$(MK_RM) $(MK_OUT)/ffile.$(OBJ_EXT)
#	$(MK_RM) $(MK_OUT)/asf.$(OBJ_EXT)
#	$(MK_RM) $(MK_OUT)/fraw.$(OBJ_EXT)
#	$(MK_RM) $(MK_OUT)/mathematics.$(OBJ_EXT)
#	$(MK_RM) $(MK_OUT)/swscale.$(OBJ_EXT)
#	$(MK_RM) $(MK_OUT)/rgb2rgb.$(OBJ_EXT)
#	$(MK_RM) $(MK_OUT)/yuv2rgb.$(OBJ_EXT)


