ifndef __SYMBIAN_ABLD_DEF_MK
__SYMBIAN_ABLD_DEF_MK=1


# XXX temporary
SYMBIAN_ROOT=$(EPOCROOT)

MK_TEMPLATE_ROOT=$(MK_DEVEL)/make/template

ifndef SYMBIAN_EX_UID
# this value and SYMBIAN_APP_ID defined in gemain.cpp are the same
SYMBIAN_EX_UID=0000001
endif

ifndef SYMBIAN_SH_UID
SYMBIAN_SH_UID=0001235
endif

ifeq ("$(SYMBIANSDK)","2")
_SYMBIAN_EX_UID=0x1$(SYMBIAN_EX_UID)
_SYMBIAN_SH_UID=0x1$(SYMBIAN_SH_UID)
_APP_EXT=app
else
_SYMBIAN_EX_UID=0x8$(SYMBIAN_EX_UID)
_SYMBIAN_SH_UID=0x8$(SYMBIAN_SH_UID)
_APP_EXT=exe
endif

EX_SUFF=.$(_APP_EXT)
SYMBIAN_ABLD=abld.bat

ifndef SYMBIAN_TARGET
SYMBIAN_TARGET=wins
endif

ifeq ($(SYMBIAN_TARGET),wins)
OBJ_EXT=obj
EXPORT_DEF=-D__WINS__
else
OBJ_EXT=o
endif

# force to regenerate mmp if mk is modified
OBJ_EXT=x

ifndef MK_MODE
MK_MODE=r
endif

ifeq ("$(MK_MODE)","d")
SYMBIAN_MODE=udeb
else
SYMBIAN_MODE=urel
endif

MK_PLATFORM=symbian
MK_SHORT_PLATFORM=sym
MK_SHORT_OS=sym
MK_PLATFORM_EXT=cpp

ifndef EX_NAME
EX_NAME=a
endif

ifndef SH_NAME
SH_NAME=shared
endif


MK_SH=$(SYMBIAN_ROOT)/epoc32/release/$(SYMBIAN_TARGET)/$(SYMBIAN_MODE)
_OUTPUT_PATH=$(MK_SH)/z/system/apps/$(EX_NAME)/
MK_OUT=$(SYMBIAN_ROOT)/epoc32/BUILD/DEVEL/make/$(MK_MAKEFILE)/$(EX_NAME)/$(SYMBIAN_TARGET)/$(SYMBIAN_MODE)
MK_EX=$(MK_SH)

MK_RM=rm -f

# some system dependent definitions
LAUNCH=cmd /c $(MK_TEMPLATE_ROOT)\etc\util\\
_LAUNCH=$(MK_TEMPLATE_ROOT)\etc\util\\
IF_EXIST=cmd /c if exist
IF_NOT_EXIST=cmd /c if not exist
THEN=
ENDIF=
DIRSEP=\\

ifndef MK_VENDOR
MK_VENDOR=Unknown
endif

MK_PACKAGE=$(LAUNCH)sympkg $(MK_MAKEFILE) $(EX_NAME) $(_SYMBIAN_EX_UID) $(MK_VENDOR)

EXENTRY=mmpentry etc/$(MK_MAKEFILE)/$(EX_NAME).mmp
SHENTRY=mmpentry etc/$(MK_MAKEFILE)/$(SH_NAME).mmp
EX_CC=$(EXENTRY) SOURCE $(EX_NAME) "$(_APP_EXT)  stack=$(EX_STACKSIZE)  heap=$(EX_HEAPMIN) $(EX_HEAPMAX)" $(_SYMBIAN_EX_UID)
EX_RC=$(EXENTRY) RESOURCE $(EX_NAME) $(_APP_EXT) $(_SYMBIAN_EX_UID)
EX_AIF=$(EXENTRY) AIF $(EX_NAME) $(_APP_EXT) $(_SYMBIAN_EX_UID)
EX_CXX=$(EX_CC)
SH_CC=$(SHENTRY) SOURCE $(SH_NAME) dll $(_SYMBIAN_SH_UID)
SH_CXX=$(SH_CC)

# ws32.lib : RWindowGroup
# apgrfx.lib : TApaTask

_SH_LIB=euser.lib apparc.lib cone.lib eikcoctl.lib eikcore.lib avkon.lib commonengine.lib commondialogs.lib efsrv.lib esock.lib c32.lib apgrfx.lib ws32.lib

_EX_LIB=$(_SH_LIB)

LSH_SUFF=.lib
SH_SUFF=.dll

# Libraries
LIB_SYSTEM=hal.lib
LIB_C=estlib.lib
LIB_COMM=c32.lib
# commonui : CDocumentHandler
LIB_UI=commonui.lib fbscli.lib bitgdi.lib gdi.lib fepbase.lib
LIB_BLUETOOTH=bluetooth.lib btextnotifiers.lib btmanclient.lib sdpagent.lib sdpdatabase.lib
LIB_FTP=ftpprot.lib
LIB_INET=insock.lib
# MediaClientVideo : CVideoRecorderUtility, CVideoPlayerUtility
LIB_MM=MediaClientVideo.lib

LIB_AUDIO=mediaclientaudiostream.lib mediaclientaudioinputstream.lib

ifdef SH_DEF
ifeq ($(SYMBIAN_TARGET),wins)
_SH_DEF_TARGET=$(MK_DEVEL)\\etc\bwins\\$(SH_DEF)u.def
else
ifeq ($(SYMBIAN_TARGET),armi)
_SH_DEF_TARGET=$(MK_DEVEL)\\etc\bmarm\\$(SH_DEF)u.def
else
_SH_DEF_TARGET=$(MK_DEVEL)\\etc\eabi\\$(SH_DEF)u.def
endif
endif
endif

O_DEF=-D
MKO_FILE=-f
endif

# EOF

