#include $(MK_TEMPLATE_ROOT)/symbol.mk
MK_EXECUTE_INCLUDED=1
include $(MK_TEMPLATE)/def.mk

ifndef EX_SRCEXT
EX_SRCEXT=c
endif


_OUTPUT_NAME=$(_OUTPUT_PATH)/$(EX_NAME).$(_APP_EXT)

ifeq (WINS,$(findstring WINS, $(PLATFORM)))
ZDIR=$(EPOCROOT)epoc32\release\$(PLATFORM)\$(CFG)\Z
else
ZDIR=$(EPOCROOT)epoc32\data\z
endif
ifeq ("$(SYMBIANSDK)","3")
_EX_MAIN_ICON=$(ZDIR)\resource\apps\$(EX_NAME)_aif.mif
endif

# assume a shared library should be built if EX_DEPEND is used

#$(_OUTPUT_NAME)
exnull : etc/$(MK_MAKEFILE)/$(SYMBIAN_ABLD) $(_SH_DEF_TARGET) $(_EX_MAIN_ICON)
	$(LAUNCH)symbuild $(SYMBIAN_TARGET) $(SYMBIAN_MODE) $(_SYMBIAN_EX_UID)
#touch $(MK_MAKEFILE)/$(SYMBIAN_ABLD)

ifdef _EX_MAIN_ICON
$(_EX_MAIN_ICON) :
	sh $(MK_TEMPLATE_ROOT)/etc/util/mifgen $(_EX_MAIN_ICON) $(EX_MAIN_RESOURCE) $(EX_NAME)
endif

ifdef EX_DEPEND
etc/$(MK_MAKEFILE)/$(SYMBIAN_ABLD) : etc/$(MK_MAKEFILE)/$(EX_NAME).mmp etc/$(MK_MAKEFILE)/$(SH_NAME).mmp
	sh $(MK_TEMPLATE_ROOT)/etc/util/bldentry $(SH_NAME).mmp
	sh $(MK_TEMPLATE_ROOT)/etc/util/bldentry $(EX_NAME).mmp
else
etc/$(MK_MAKEFILE)/$(SYMBIAN_ABLD) : etc/$(MK_MAKEFILE)/$(EX_NAME).mmp
	sh $(MK_TEMPLATE_ROOT)/etc/util/bldentry $(EX_NAME).mmp
endif
	$(LAUNCH)\makeabld $(SYMBIAN_TARGET)



etc/$(MK_MAKEFILE)/$(EX_NAME).mmp : make/$(MK_MAKEFILE).mk
	$(IF_NOT_EXIST) etc$(DIRSEP)$(MK_MAKEFILE) $(THEN) mkdir etc$(DIRSEP)$(MK_MAKEFILE)
	$(ENDIF)
	touch mmpprog.ex
	make -f make/$(MK_MAKEFILE).mk clean_exmake
	make -f make/$(MK_MAKEFILE).mk EX_MMP
	$(EXENTRY) EMIT SYSTEMINCLUDE \epoc32\include
	$(EXENTRY) EMIT SYSTEMINCLUDE \epoc32\include\libc
	$(EXENTRY) EMIT SYSTEMINCLUDE ..\..
	$(EXENTRY) OPTION $(MK_CC_OPT)
	$(EXENTRY) LIBRARY $(EX_LIB) $(_EX_LIB)
	$(EXENTRY) EMIT LANG SC
	$(MK_RM) mmpprog.ex

ifdef EX_MAIN_PLATFORM
_GE_MAIN_MODULE=$(MK_OUT)/gemain.$(OBJ_EXT)

ifeq ("$(EX_MAIN_RESOURCE)","")
EX_MAIN_RESOURCE=$(MK_TEMPLATE)
endif
ifeq ("$(EX_MAIN_RESOURCE)","default")
EX_MAIN_RESOURCE=$(MK_TEMPLATE)
endif
ifeq ("$(EX_MAIN_RESOURCE)","custom")
EX_MAIN_RESOURCE=$(EX_SRCPATH)/resource
endif
_GE_MAIN_RESOURCE=$(MK_OUT)/$(EX_NAME)res.rsc


endif

_SYMBIAN_EX_UID_HEADER=$(MK_DEVEL)/etc/$(EX_NAME)uid.h

EX_MMP: $(_SYMBIAN_EX_UID_HEADER) $(_GE_MAIN_MODULE) $(_GE_MAIN_RESOURCE) EX_NULL $(EX_OBJ)

ifndef SYMBIAN_EX_UID_FILE
SYMBIAN_EX_UID_FILE=make/$(MK_MAKEFILE).mk
endif


$(_GE_MAIN_MODULE) : $(MK_DEVEL)/ge/gemain.cpp
	$(EX_CC) $(MK_DEVEL)/ge/gemain.cpp

$(_GE_MAIN_RESOURCE) : $(EX_MAIN_RESOURCE)/$(EX_NAME)res.c $(_SYMBIAN_EX_UID_HEADER)
	$(EX_RC) $(MK_DEVEL)/etc/$(EX_NAME).rss
	sh $(MK_TEMPLATE_ROOT)/etc/util/symres caption $(EX_MAIN_RESOURCE) $(EX_NAME) $(EX_RC)

ifneq ("$(SYMBIANSDK)","2")
	$(EX_RC) $(MK_DEVEL)/etc/$(EX_NAME)reg.rss
	sh $(MK_TEMPLATE_ROOT)/etc/util/symres reg $(EX_MAIN_RESOURCE) $(EX_NAME) $(_SYMBIAN_EX_UID)
endif

#	if exist $(EX_MAIN_RESOURCE)/$(EX_NAME).bmp sh $(MK_TEMPLATE_ROOT)/etc/util/symres aif $(EX_MAIN_RESOURCE) $(EX_NAME) $(_SYMBIAN_EX_UID_HEADER) $(EX_AIF)
	if exist $(EX_MAIN_RESOURCE)/$(EX_NAME).xpm sh $(MK_TEMPLATE_ROOT)/etc/util/symres aif $(MK_DEVEL)/etc $(EX_NAME) $(_SYMBIAN_EX_UID_HEADER) $(EX_AIF)

$(_SYMBIAN_EX_UID_HEADER) : $(SYMBIAN_EX_UID_FILE)
	echo #define SYMBIAN_APP_ID $(_SYMBIAN_EX_UID) > $(_SYMBIAN_EX_UID_HEADER)


EX_NULL: $(EX_SRCPATH)/$(EX_SRC).$(EX_SRCEXT)
	$(EX_CC) $(EX_SRCPATH)/$(EX_SRC).$(EX_SRCEXT)

clean_execute:
	$(IF_EXIST) etc$(DIRSEP)$(MK_MAKEFILE)$(DIRSEP)$(SYMBIAN_ABLD) $(THEN) $(LAUNCH)symclean $(SYMBIAN_TARGET) $(SYMBIAN_MODE)
	$(ENDIF)
	make -f make/$(MK_MAKEFILE).mk clean_exmake

clean_exmake:
	$(MK_RM) etc/$(MK_MAKEFILE)/$(EX_NAME).mmp
	$(MK_RM) etc/$(MK_MAKEFILE)/$(SYMBIAN_ABLD)
	$(MK_RM) etc/$(MK_MAKEFILE)/bld.inf
	$(MK_RM) $(_SYMBIAN_EX_UID_HEADER)
ifdef _GE_MAIN_MODULE
	$(MK_RM) $(MK_OUT)/gemain.$(OBJ_EXT)
endif
ifdef _GE_MAIN_RESOURCE
	$(MK_RM) $(MK_OUT)/$(EX_NAME).rsc
endif
	$(MK_RM) etc/$(EX_NAME).pkg
ifdef _EX_MAIN_ICON
	$(MK_RM) $(_EX_MAIN_ICON)
endif

debug:
	runwin msdev "$(_OUTPUT_NAME)"

package_common:
	$(MK_PACKAGE) resource $(EPOCROOT)epoc32\data\z\system\apps\$(EX_NAME)\$(EX_NAME).rsc
ifeq ("$(SYMBIANSDK)","2")
	$(MK_PACKAGE) resource $(EPOCROOT)epoc32\data\z\system\apps\$(EX_NAME)\$(EX_NAME)_caption.rsc optional
	$(MK_PACKAGE) resource $(EPOCROOT)epoc32\data\z\system\apps\$(EX_NAME)\$(EX_NAME).aif optional
else
	sh $(MK_TEMPLATE_ROOT)/etc/util/iconpkg $(EX_MAIN_RESOURCE)/$(EX_NAME) $(MK_PACKAGE) resource $(EPOCROOT)epoc32\data\z\resource\apps\$(EX_NAME)_aif
endif
	$(MK_PACKAGE) private $(EPOCROOT)epoc32\data\z\system\apps\$(EX_NAME)\$(EX_NAME)reg.rsc

