# Makefile to generate a shared library file
# Hee S. Chung, Distributed under GNU LGPL

!if "$(SH_SRCEXT)"=="java" || "$(SH_SRCEXT)"=="jws"
!include $(MK_TEMPLATE_ROOT)\java\shared.d
!else
!include $(MK_TEMPLATE)\def.d


!ifdef SH_SRC


!ifndef SH_SRCPATH
SH_SRCPATH=.
!endif


!ifndef SH_SRCEXT
SH_SRCEXT=c
!endif

!ifndef SH_NAME
SH_NAME=$(SH_SRC)
!endif

_SH_SRC_OBJ=$(MK_OUT)\$(SH_SRC).obj
_SH_RM_SRC_OBJ= $(MK_RM) $(_SH_SRC_OBJ)

!else

!ifndef SH_NAME
SH_NAME=shared
!endif

!endif # SH_SRC

SH_CC=$(_MK_CC)
SH_CXX=$(_MK_CXX)

!if "$(SH_SRCEXT)"=="c"
_SH_CC=$(SH_CC)
!else
_SH_CC=$(SH_CXX)
!endif


!ifdef SH_DEF
_SH_DEF_FILE=$(MK_DEVEL)\etc\$(SH_DEF).def
SH_DEF_OPT=/DEF:$(_SH_DEF_FILE)
#SH_DEF_PATH)/$(SH_DEF).def
!endif


# Generate library

$(LSH_PREF)$(SH_NAME)$(LSH_SUFF) : $(MK_SH)\$(SH_PREF)$(SH_NAME)$(SH_SUFF)
	@echo $(MK_SH)\$(SH_PREF)$(SH_NAME)$(SH_SUFF)

$(MK_SH)\$(SH_PREF)$(SH_NAME)$(SH_SUFF): $(_SH_SRC_OBJ) $(SH_OBJ) $(SH_DEPEND) $(_SH_DEF_FILE)
	link /DLL $(_MK_LD_OPT) $(MK_LD_OPT) /IMPLIB:$(MK_LIB)\$(ST_PREF)$(SH_NAME)$(ST_SUFF) /OUT:$(LIBW_DLL_FILE) $(SH_DEF_OPT) $(_SH_SRC_OBJ) $(SH_OBJ) $(SH_LIB)

!ifdef SH_DEF
$(_SH_DEF_FILE) : $(SH_DEF_PATH)/$(SH_DEF).c
	$(_SH_CC) /E $(SH_DEF_PATH)/$(SH_DEF).c | windef > $(_SH_DEF_FILE)
!endif

# Generate source object file

!ifdef SH_SRC
$(_SH_SRC_OBJ) : $(SH_SRCPATH)\$(SH_SRC).$(SH_SRCEXT) $(SH_SRCDEP)
	$(_SH_CC) $(SH_SRCPATH)\$(SH_SRC).$(SH_SRCEXT)
!endif


# Clean output files

clean_shared:
	$(_SH_RM_SRC_OBJ)
	$(MK_RM) $(MK_LIB_PATH)\$(ST_PREF)$(SH_NAME)$(ST_SUFF)
	$(MK_RM) $(LIBW_DLL_FILE)

!endif

# end of shared.d

