#define _USE_WINOS_ALL
#include <string.h>
#include <coralsrc/process.c>
#include <coralsrc/list.c>
#include <coralsrc/dl.c>
#include <coralsrc/bintree.c>
#include <coralsrc/iotext.c>
#include <coralsrc/string.c>
#include <coralsrc/io.c>
#include <coralsrc/iox.c>
#include <coralsrc/file.c>
#include <coralsrc/compat/c_stdio.c>
#include <coralsrc/memory.c>
//#include <coral/string.h>
//#include <coral/io.h>
//#include <coral/file.h>
#include <coral/compat/stdio.h>

struct _STDIOCONTEXT scc;
struct _IOCONTEXT io = { stdioReadString, stdioWriteString, NULL, &scc };
struct _IOLOCKCONSOLE ioc;
struct _IOTEXT iot = { {&ioc,ioLockConsole,ioUnlockConsole} };
char buf[256];
struct _MEMEXP bufexp = { buf, -(int)sizeof(buf) };


#define MAKEDEF_DEFAULT  0
#define MAKEDEF_CYGWIN   1
#define MAKEDEF_SYMBIAN  2

struct _makedef_target {
	const char* name;
	unsigned id;
} target[] = {
	{ "cygwin", MAKEDEF_CYGWIN },
	{ "symbian", MAKEDEF_SYMBIAN },
};

int
main( int argc, char* argv[] )
{
	unsigned ordinal;
	unsigned target_id = 0;

	if( argc>1 ) {
		int i;
		for( i=0; i<sizeof(target)/sizeof(target[0]); i++ ) {
			if( strcmp( target[i].name, argv[1] )==0 ) {
				target_id = target[i].id;
				break;
			}
		}
	}

	scc.in = scc.stdio_in = stdin;
	scc.out = scc.stdio_out = stdout;
	scc.stdio_fgets = fgets;
	scc.stdio_fputs = fputs;
	ioInitializeConsoleBuffer( &ioc, &io );
	ioAllocConsoleBuffer( &ioc, 256, 0 );

	puts( "EXPORTS" );

	ordinal = 1;
	for(;;) {
		while( iotextObserve( &iot, NULL )>0 ) {
			if( iot.lastchar=='#' ) {
				iotextSkipLine( &iot, 1 );
			}
			else {
				if( iotextRead( &iot, NULL, &bufexp, 0, 0 )>0 ) {
					int index;
					if( target_id && (index=strTokenIndex(buf,"@",0))>=0 ) {
						if( target_id==MAKEDEF_SYMBIAN ) buf[index] = 0;
						printf( "%s", buf+1 );
					}
					else {
						printf( "%s", buf );
					}

					printf( " @ %d ", ordinal++ );

					if( target_id>0 )
						printf( "NONAME" );

					printf( "\n" );
				}
				else
					break;
			}
		}
		if( ioResetConsoleState( &ioc )<0 ) break;
	}

	return 0;
}



/* EOF */

